#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#define _XOPEN_SOURCE
#include <unistd.h>
#include <crypt.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* may be in shadow format or passwd format */
#define PASSWD_FILE	"/var/yp/src/shadow"
#define TMP_PASSWD_FILE	"/var/yp/src/shadow.new"

/* /usr/lib/yp/pwupdate uses lock based on a file, if yppasswdd is desabled, then you can deactivate that locking */

#define NIS_PWUPDATE	"/usr/lib/yp/pwupdate"

/* if exists contains a list of users not allowed to change password */
/* local users (not on nis) can't change password anyway */
#define NOCHANGE_FILE	"/usr/local/samba/passwd/nochange"

#define SEM_ID	56782
#define P1_STR		"Enter new password"
#define P2_STR		"Enter new password"
#define OK_STR		"changed"
#define KO_STR		"failed"


#if defined(__GNU_LIBRARY__) && !defined(_SEM_SEMUN_UNDEFINED)
       /* union semun is defined by including <sys/sem.h> */
#else
       /* according to X/OPEN we have to define it ourselves */
union semun {
            int val;                    /* value for SETVAL */
            struct semid_ds *buf;       /* buffer for IPC_STAT, IPC_SET */
            unsigned short int *array;  /* array for GETALL, SETALL */
            struct seminfo *__buf;      /* buffer for IPC_INFO */
       };
#endif



void done(int code)
{
if(code) {puts(KO_STR);exit(code);} else {puts(OK_STR); exit(0);}
}

int main(int argc, char *argv[])
{
char line[300];
char pass1[41];
char pass2[41];
char salt[3];
char *user;
int s;
char *res, *aux;
int sem, ulen;
union semun sctl;
struct sembuf sop;
FILE *f1, *f2;
time_t now;




puts(P1_STR);
fgets(pass1,40,stdin);
pass1[strlen(pass1)-1]=0;
puts(P2_STR);
fgets(pass2,40,stdin);
pass2[strlen(pass2)-1]=0;


if(argc!=2) done(1); /* no username */
user=argv[1];

if(strcmp(pass1,pass2)) done(1); /* password don't match */


ulen=strlen(user);

f1=fopen(NOCHANGE_FILE,"r"); 	/* user not allowed to change password */
if(f1) 
	{
	while(fgets(line,98,f1))
	  if(*line>='A')
		{
		line[strlen(line)-1]=0;
		if(!strcmp(line,user))
			{
			fclose(f1);done(1);
			}
		}
	fclose(f1);
	}


/* lets do it */


/* usar semaforo para exclusao mutua */

sem=semget(SEM_ID,1,IPC_CREAT|IPC_EXCL|0700);
if(sem== -1)
	{
	sem=semget(SEM_ID,1,0700);
	if(sem == -1) done(1);
	}
else
	{
	sctl.val=1;
	semctl(sem,0,SETVAL,sctl);
	}
sop.sem_num=0;
sop.sem_op= -1;
sop.sem_flg=SEM_UNDO;
semop(sem,&sop,1);

/* acesso exclusivo garantido */

f1=fopen(PASSWD_FILE,"r"); if(!f1) done(1);
f2=fopen(TMP_PASSWD_FILE,"w"); if(!f2) done(1);

while(fgets(line,98,f1))
	{
	if(!strncmp(line,user,ulen) && line[ulen]==':')
		{
		aux=line+ulen+1;
		while(*aux != ':') aux++;
		fputs(user,f2);
		s=getpid();
		time(&now);
		salt[0]=salt[0]-(char)s+(char)now;
		salt[1]=salt[1]+(char)s-(char)now;
		salt[2]=0;
		while(salt[0]<'0' || (salt[0]>'9' && salt[0]<'A') || (salt[0]>'Z' && salt[0]<'a') || salt[0]>'z')
			salt[0]+=7;
		while(salt[1]<'0' || (salt[1]>'9' && salt[1]<'A') || (salt[1]>'Z' && salt[1]<'a') || salt[1]>'z')
			salt[1]+=7;


		fputs(":",f2);
		res=crypt(pass1,salt);
		fputs(res,f2);
		fputs(aux,f2);
		}
	else
		{
		fputs(line,f2);
		}
	}
fclose(f1);
fclose(f2);

f1=fopen(TMP_PASSWD_FILE,"r");
f2=fopen(PASSWD_FILE,"w");
while(fgets(line,98,f1))
	fputs(line,f2);
fclose(f1);
fclose(f2);

system(NIS_PWUPDATE);

unlink(TMP_PASSWD_FILE);

sop.sem_num=0;
sop.sem_op= 1;
sop.sem_flg=SEM_UNDO;
semop(sem,&sop,1);
done(0);
exit(0);
}




